<?php 

$currentUser = $_SESSION['priv'];

$url = $_SERVER['REQUEST_URI'];

if(isset($_POST['submit'])){
    $fName = $_POST['fname'];
    $sName = $_POST['sname'];
    $email = $_POST['email'];
    $password = $_POST['password'];
    $active = $_POST['status'];
    $priv = $_POST['type'];
    $hashedPassword = password_hash($password, PASSWORD_DEFAULT);

    $errors= array();

    //if a file exists, get the file information
    $file_name =$_FILES['fileName']['name'];
    $file_size =$_FILES['fileName']['size'];
    $file_tmp =$_FILES['fileName']['tmp_name'];
    $file_type=$_FILES['fileName']['type'];

    //Above line splits all the file name from the file extension and saves the extension on $file_ext
    $file_name_parts = explode('.', $_FILES['fileName']['name']);
$file_ext = strtolower(end($file_name_parts));
   
    //List all the allowed file type extensions
    $extensions= array("jpeg","jpg","png","gif");
    
    //checked if the file extension is allowed and if not, record the error in to the $errors array.
    if(in_array($file_ext,$extensions)=== false){
       $errors[]="extension not allowed, please choose a different file type.";
    }

    //Checks to see if the file size is too large. Comment out if not required
    if($file_size > 2097152){
       $errors[]='File size must be under 2 MB';
    }
    

    if(empty($fName) || empty($sName) || empty($email) || empty($password) || empty($active) || empty($priv) || empty($file_name)) {
           echo '<script>alert("Error: All fields are required.")</script>';
          echo '<script>window.location.href = "'.$url.'";</script>';
    } else {
    $query = "INSERT INTO users(fname, sname, email, pw,active,priv,avatar) VALUES (?, ?, ?, ?, ?, ?,?)";
    connectDB();

    $stmt = mysqli_prepare($_SESSION['db'], $query);
    if ($stmt) {
            //If there the $errors array is empty, upload the file
    if(empty($errors)==true){
        move_uploaded_file($file_tmp,"uploads/".$file_name);
     }
        mysqli_stmt_bind_param($stmt, 'sssssss', $fName, $sName, $email, $hashedPassword,$active,$priv,$file_name);
        if (mysqli_stmt_execute($stmt)) {
            // Insert successful
                   echo '<script>alert("Success: User added successfully")</script>';
          echo '<script>window.location.href = "'.$url.'";</script>';
        } else {
            // Insert failed
            echo "Error: " . mysqli_error($_SESSION['db']);
        }
        mysqli_stmt_close($stmt);
    } else {
        // Statement preparation failed
        echo "Error: " . mysqli_error($_SESSION['db']);
    }

    closeDB();
}
}

// select user queries
    if($currentUser != 3){
    $query = "SELECT * FROM users WHERE (priv = 2 OR priv = 1) ORDER BY priv DESC";
    }else{
            $query = "SELECT * FROM users ORDER BY priv DESC";
    }
    connectDB();

    $stmt = mysqli_prepare($_SESSION['db'], $query);
    mysqli_stmt_execute($stmt);
    $result = mysqli_stmt_get_result($stmt);

    closeDB();

    // select user edituser
    if($currentUser != 3){
    $query1 = "SELECT * FROM users WHERE priv < ?  ORDER BY priv DESC";
     }else{
    $query1 = "SELECT * FROM users WHERE priv <= ?  ORDER BY priv DESC";
    }
    connectDB();

    $stmt1 = mysqli_prepare($_SESSION['db'], $query1);
    mysqli_stmt_bind_param($stmt1, 's', $currentUser);
    mysqli_stmt_execute($stmt1);
    $result1 = mysqli_stmt_get_result($stmt1);

    closeDB();

    // delete user
    if(isset($_POST['delete'])){
        $id = $_POST['id'];

        $query = "DELETE FROM users WHERE id = ?";
        connectDB();
    
        $stmt = mysqli_prepare($_SESSION['db'], $query);
        mysqli_stmt_bind_param($stmt, 's', $id);
        if (mysqli_stmt_execute($stmt)) {
            // Deleted successful
            echo "Record Deleted Successfully.";
        } 
        
        closeDB();
    }

    // update records
    if(isset($_POST['update'])){
        $id = $_POST['id'];
        $fName = $_POST['fname'];
    $sName = $_POST['sname'];
    $email = $_POST['email'];
    $active = $_POST['status'];
    $priv = $_POST['type'];

    $errors= array();

    //if a file exists, get the file information
    $file_name =$_FILES['fileName']['name'];
    $file_size =$_FILES['fileName']['size'];
    $file_tmp =$_FILES['fileName']['tmp_name'];
    $file_type=$_FILES['fileName']['type'];

    //Above line splits all the file name from the file extension and saves the extension on $file_ext
    $file_name_parts = explode('.', $_FILES['fileName']['name']);
$file_ext = strtolower(end($file_name_parts));
   
    //List all the allowed file type extensions
    $extensions= array("jpeg","jpg","png","gif");
    
    //checked if the file extension is allowed and if not, record the error in to the $errors array.
    if(in_array($file_ext,$extensions)=== false){
       $errors[]="extension not allowed, please choose a different file type.";
    }

    //Checks to see if the file size is too large. Comment out if not required
    if($file_size > 2097152){
       $errors[]='File size must be under 2 MB';
    }

    if(empty($fName) || empty($sName) || empty($active) || empty($priv)) {
          echo '<script>alert("Error: All fields are required.")</script>';
          echo '<script>window.location.href = "'.$url.'";</script>';
    } elseif(move_uploaded_file($file_tmp,"uploads/".$file_name)) {

        $query = "UPDATE users SET fname=?,sname=?,active=?,priv=?,avatar=? WHERE id = ?";
        connectDB();
        $stmt = mysqli_prepare($_SESSION['db'], $query);

        mysqli_stmt_bind_param($stmt, 'ssssss', $fName, $sName, $active,$priv,$file_name,$id);
    }else{
        $query = "UPDATE users SET fname=?,sname=?,active=?,priv=? WHERE id = ?";
        connectDB();
        $stmt = mysqli_prepare($_SESSION['db'], $query);

        mysqli_stmt_bind_param($stmt, 'sssss', $fName, $sName, $active,$priv,$id);
    }
        if (mysqli_stmt_execute($stmt)) {
            // Update successful
              echo '<script>alert("Success: Record updated successfully.")</script>';
          echo '<script>window.location.href = "'.$url.'";</script>';
        } else {
            // Update failed
            echo "Error: " . mysqli_error($_SESSION['db']);
        }
        mysqli_stmt_close($stmt);


    closeDB();

    }

?>
<div class="container">
    <div class="display-btn">
   <div class="add" id="addbtn">  <a href="javascript:void(0)">Add User</a></div>
  <div class="edit" id="editbtn">  <a href="javascript:void(0)">Edit User</a></div>
</div>
</div>
<!-- edit user -->
<div class="edit-user" id="edit" style="display:none">
    <form method="POST" action="" enctype="multipart/form-data">
   <legend>Edit User</legend>
    <input type="hidden" value="" name="id" id="Eid">
<div class="input-wrap">
         <div class="input-box">
          <label for="fileName">User</label><select name="type" id="userSelect" required>
          <option value="">Select User For Edit</option>
          <?php while( $row1 = mysqli_fetch_assoc($result1)){ ?>  ?>
          <option value="<?php echo $row1['id'] ?>"><?php echo $row1['fname']; ?></option>
          <?php } ?>
      </select>
     </div>
     <div class="input-box">
          <label for="fileName">User Type</label><select name="type" id="Etype" required>
          <option value="">Choose User Type</option>
          <option value="1">STANDARD USER</option>
          <?php if($currentUser == 3){ ?>
          <option value="2">ADMIN</option>
          <option value="3">SUPER ADMIN</option>
          <?php } ?>
      </select>
     </div>
</div>
    <div class="input-wrap"> <div class="input-box">
          <label for="fileName">First Name</label><input type="text" id="Efname" value="" name="fname" required>
     </div>
     <div class="input-box">      <label for="fileName">Sur Name</label><input type="text" id="Esname" value="" name="sname" required></div></div>
  <div class="input-wrap"> <div class="input-box">
          <label for="fileName">Email</label><input type="email" id="Eemail" value="" name="email" readonly disabled>
    </div>
     <div class="input-box"> <label for="fileName">Status</label><select name="status" id="Estatus">
          <option value="">Choose User Status</option>
          <option value="y" >Active</option>
          <option value="n">Inactive</option>
      </select></div>
      </div>
  
    <div class="input-box">  <label for="fileName">Avtar</label><input type="file" id="Eavatar" name="fileName"></div>
   

    
      <div class="input-box"> <img id="avatarPreview" src="" style="max-width: 200px; max-height: 200px;"></div>
     <div class="edit-btn"> 
     <button type="submit" name="update" value="Upload File">Update</button>
     <a href="javascript:void(0)" id="cancel">Cancel</a>
     </div>
   
  </form><br><br>
</div>

  <!-- add user -->
<div class="edit-user" id="add" style="display:none">
      <form method="POST" action="" enctype="multipart/form-data" style="background-color: rgb(89,166,255);">
<legend>Add New User</legend>
      <div class="input-wrap">
         <div class="input-box"> <label for="fileName">User Type</label><select name="type" id="" required>
          <option value="">Choose User Type</option>
          <option value="1">STANDARD USER</option>
          <?php if($currentUser == 3){ ?>
          <option value="2">ADMIN</option>
          <option value="3">SUPER ADMIN</option>
          <?php } ?>
      </select></div>
     <div class="input-box"> <label for="fileName">First Name</label><input type="text" id="fileName" name="fname" required></div>
      </div>
      <div class="input-wrap">
                <div class="input-box"><label for="fileName">Sur Name</label><input type="text" id="fileName" name="sname" required></div>
      <div class="input-box">  <label for="fileName">Email</label><input type="email" id="fileName" name="email" required></div>
      </div>
      <div class="input-wrap">
                <div class="input-box"><label for="fileName">Password</label><input type="password" id="fileName" name="password" minlength="6" required></div>
      <div class="input-box">    <label for="fileName">Status</label><select name="status" id="" required>
          <option value="">Choose User Status</option>
          <option value="y">Active</option>
          <option value="n">Inactive</option>
      </select></div>
      </div>
      
     <div class="input-box"> <label for="fileName">Avtar</label><input type="file" id="fileName" name="fileName" required></div>
    
     <div class="edit-btn"> <button type="submit" name="submit" value="Upload File">Submit</button>
     <a href="javascript:void(0)" id="cancel" class="clr">Cancel</a>
     </div>
    
  </form>
</div>

 <div class="user-table">
      <table>
    <thead>
        <tr>
        <th>Sr No</th>
        <th>Image</th>
        <th>First Name</th>
        <th>Last Name</th>
        <th>Email</th>
        <th>User Privileges</th>
        <th>Status</th>
        <?php if($currentUser == 3){ ?>
        <th>Action</th>
        <?php } ?>
</tr>
    </thead>
    <tdata>
        <?php 
        $n=1;
        while( $row = mysqli_fetch_assoc($result)){ ?>
        <tr>
            <td><?php echo $n++; ?></td>
            <?php if($row['avatar'] != ''){ ?>
            <td><img height="100px" src="uploads/<?php echo $row['avatar']; ?>"></td>
            <?php }else{ ?>
                <td>-</td>
                <?php } ?>
            <td><?php echo $row['fname']; ?></td>
            <td><?php echo $row['sname']; ?></td>
            <td><?php echo $row['email']; ?></td>
            <?php if($row['priv'] == 1){ ?>
            <td>STANDARD USER</td>
            <?php }elseif($row['priv'] == 2){ ?>
                <td>ADMIN</td>
                <?php }elseif($row['priv'] == 3){ ?>
                    <td>SUPER ADMIN</td>
                    <?php } ?>
                    <?php if($row['active'] == 'y'){ ?>
            <td>ACTIVE</td>
            <?php }elseif($row['active'] == 'n'){ ?>
                <td>IN-ACTIVE</td>
                    <?php } ?>
                       <?php if($currentUser == 3){ ?>
                    <td>
                    <?php if($row['priv'] != 3){ ?>
                    <form method="POST">
                        <input type="hidden" name="id" value="<?php echo $row['id']; ?>">
                    <button onclick="return confirm('Aye You Sure To Delete The Selected User')" name="delete">Delete</button>
                    </form>
                    <?php }else{ ?>
                    -
                    <?php } ?>
                </td>
                <?php } ?>
        </tr>
        <?php } ?>
    </tdata>
</table>
 </div>

<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.7.1/jquery.min.js"></script>
<script>
    document.getElementById('userSelect').addEventListener('change', function() {
        var userId = this.value;
        $.ajax({
            url: 'script.php', // Replace with the actual URL to your server-side script
            method: 'POST',
            data: { 
                request: 'post',
                userId: userId
             },
            success: function(response) {
                // console.log('Response from server:', response);
                var userDetails = JSON.parse(response);

                // alert(userDetails);
                document.getElementById('Efname').value = userDetails.fname;
                document.getElementById('Esname').value = userDetails.sname;
                document.getElementById('Eemail').value = userDetails.email;
                document.getElementById('Estatus').value = userDetails.active;
                document.getElementById('Etype').value = userDetails.priv;
                document.getElementById('Eid').value = userDetails.id;
                
                // alert(userDetails.priv);

                if (userDetails.avatar) {
                document.getElementById('avatarPreview').src = 'uploads/' + userDetails.avatar;
                document.getElementById('avatarPreview').style.display = 'block'; // Show the image
            } else {
                document.getElementById('avatarPreview').style.display = 'none'; // Hide the image
            }
            
             var statusField = document.getElementById('Estatus');
            if (userDetails.priv == 3) {
                statusField.removeAttribute('required');
                statusField.setAttribute('readonly', 'readonly');
                statusField.disabled = true;
            } else {
                statusField.setAttribute('required', 'required');
                statusField.removeAttribute('readonly');
                statusField.disabled = false;
            }
            
            // if(userDetails.priv == 3){
                
            // }
            
            },
            error: function(xhr, status, error) {
                console.error('Error fetching user details: ' + error);
            }
        });
    });
    
    // show form
    $(document).ready(function(){
        $('#addbtn').click(function(){
            $('#add').show();
            $('#edit').hide();
        })
        
                $('#editbtn').click(function(){
            $('#edit').show();
            $('#add').hide();
        })
        
        $('#cancel').click(function(){
            $('#edit').hide();
        })
        
                $('.clr').click(function(){
            $('#add').hide();
        })
    })
    
</script>